#include <stdint.h>
#include <proc.h>
#include <memory.h>

struct swtch_stack
{
    uint64_t RBP;
    uint64_t RBX;
    uint64_t R12;
    uint64_t R13;
    uint64_t R14;
    uint64_t R15;
    uint64_t RBP2;
    uint64_t ret;
};

static uint64_t next_tid = 1;

struct thread *current_thread;

struct thread *new_thread(void (*function)(void))
{
    struct thread *th = P2V(pmm_calloc());
    th->tid = next_tid++;
    th->stack_ptr = incptr(th, PAGE_SIZE - sizeof(struct swtch_stack));
    th->q_next = 0;

    struct swtch_stack *stck = th->stack_ptr;
    stck->RBP = (uint64_t)&stck->RBP2;
    stck->ret = (uint64_t)function;

    return th;
}

struct thread *thread()
{
    return current_thread;
}